#!/bin/bash

# First create the filtered folders to store the results
#find ./results -name '*.vec' -exec sh -c 'mkdir  $(dirname {})/filtered' &> /dev/null \;

if [ $# -lt 1 ] 
then
	echo "Usage: extract_vectors.sh results_dir"
	exit 1
fi

# Run the filtering 
find "$1" -name '*.vec' -exec sh -c 'mkdir  $(dirname {})/filtered &> /dev/null; echo $(basename {}); ovfilter -s RTT -s TDOA -s "STA POSITION" -s "DIST TOA" -i {} -o $(dirname {})/filtered' \;
#find ./results -name '*.sca' -exec awk '{ if ($3 == "x") { printf $4" ";next; } else if ($3 == "y") printf $4 "\n" } ' {} > POSITIONS\;
echo '{ if ($3 == "\"number" && $4 == "of" && $5 == "collisions\"") print $6  }' > /tmp/awk_command.awk
find "$1" -name '*.sca' -exec sh -c 'awk -f /tmp/awk_command.awk {} > $(dirname {})/filtered/COLLISSIONS' \;
echo '{ if ($3 == "x") { printf $4" ";next; } else if ($3 == "y") print $4 }' > /tmp/awk_command.awk
find ./results -name '*.sca' -exec sh -c 'awk -f /tmp/awk_command.awk {} > $(dirname {})/filtered/INITIAL_POSITIONS' \;
rm /tmp/awk_command.awk &> /dev/null
