/*
 * Ieee80211Location.h
 *
 *  Created on: Mar 5, 2014
 *      Author: martamalpartida
 */
//ADDED BY MARTA
//it identifies which nodes are TOA,TDOA or it doesn't have location technique.
#ifndef IEEE80211LOCATION_H_
#define IEEE80211LOCATION_H_

#define __NO_LOCATION_TECHNIQUE (-1)
#define __TWO_WAY_TOA (0)
#define __PASSIVE_TDOA (1)

#define isTwoWayTOA(locationTechnique) (locationTechnique == __TWO_WAY_TOA)
#define isPassiveTDOA(locationTechnique) (locationTechnique == __PASSIVE_TDOA)
#define isAP(locationTechnique) (locationTechnique == __NO_LOCATION_TECHNIQUE)

#define getLocationTechnique(locationTechnique)     try { \
                                                        locationTechnique = getAncestorPar("locationTechnique"); \
                                                    } catch(std::exception & e) { \
                                                        locationTechnique = __NO_LOCATION_TECHNIQUE; \
                                                    }
#define isWirelessLocationHost(locationTechnique)  (locationTechnique != __NO_LOCATION_TECHNIQUE)

static char * locationTechniqueStr[3] = {"No location technique", "Two-way TOA", "Passive TDOA"};
#define locationTechniqueToStr(locationTechnique)   locationTechniqueStr[locationTechnique+1]

#endif /* IEEE80211LOCATION_H_ */

//--
