function bar_title( x, y, fig_title, label_x, label_y, font_size)
%Formats a basic X-Y barplot, according to the axis and font features provided
%   * x, y: vectors with the data to be displayed. They need to have the same size
%   * fig_title: Title of the figure
%   * label_x, label_y: Labels of the x and y axis respectively

if (nargin < 6)
  font_size = 16;
end

figure; bar(x,y, 1);
set(gca,'FontSize',font_size)
title(fig_title, 'FontSize', font_size);
xlabel(label_x, 'FontSize', font_size);
ylabel(label_y, 'FontSize', font_size);

saveas(gcf, fig_title, 'fig');
saveas(gcf, fig_title, 'png');
%saveas(gcf, fig_title, 'pdf');
close


end

