function [ rtt_mac, rtt_mngt, tdoa, error_rtt_mac, error_rrt_mngt, error_tdoa, dist_an, dist_pn, collisions_an, collisions_pn, positions_an, positions_pn] = read_data( path, samples, num_an, num_pn)
%   Detailed explanation goes here
    
    format long;

    rtt_mac = load_matrix (path, 'RTT MAC*.txt', samples);
    rtt_mngt = load_matrix (path, 'RTT MNGT*.txt', samples);
    tdoa = load_matrix_extended (path, 'TDOA (time)*.txt', num_an, samples);
    error_rtt_mac = load_matrix (path, 'RTT MAC ERROR*.txt', samples);
    error_rrt_mngt = load_matrix (path, 'RTT MNGT ERROR*.txt', samples);
    error_tdoa = load_matrix_extended(path, 'TDOA (time error)*.txt', num_an, samples);
    dist_an = load_matrix (path, 'DIST TOA*.txt', samples);
    dist_pn = load_matrix (path, 'TDOA (distance)*.txt', samples);
    [collisions_an, collisions_pn] = load_collisions (path, 'COLLISIONS.txt', num_an, num_pn);
end

function out = load_matrix_extended ( path, filter, num_an, samples)

   f = dir([ path '/' filter ]);
   
   out = cell(length(f), num_an);
   
   i = 1;
   k = 1;
   
   if (nargin < 4 || samples == CONSTANTS.ALL)
        while k < length(f)
            for j = 1:num_an
                out{i,j}=load( [ path '/' f(i).name ] );
            end
            i = i + 1;
            k = k + num_an;
        end
   else
        while k < length(f)
            for j = 1:num_an
                temporal=load( [ path '/' f(i).name ] );
                totalSamples = length(temporal);
                if (samples < totalSamples)
                   out{i,j}=temporal(totalSamples-samples+1:totalSamples, 1:col_num);
                else
                   out{i,j}=temporal(1:totalSamples, 1:col_num);
                end
            end
            i = i + 1;
            k = k + num_an;
        end
   end

end

function out = load_matrix ( path, filter, samples)

   f = dir([ path '/' filter ]);
   
   out = cell(1,length(f));
   
   if (nargin < 3 || samples == CONSTANTS.ALL_SAMPLES)
        for i=1:length(f)
            out{i}=load( [ path '/' f(i).name ] );
        end
   else
        for i=1:length(f)
            temporal=load( [ path '/' f(i).name ] );
            totalSamples = length(temporal);
            if (samples < totalSamples)
               out{i}=temporal(totalSamples-samples+1:totalSamples, 1:col_num);
            else
               out{i}=temporal(1:totalSamples, 1:col_num);
            end       
        end
   end

end

function [col_an, col_pn] = load_collisions ( path, filter, num_an, num_pn )
 
  f = dir([ path '/' filter ]);
        
   col_an = zeros(num_an, length(f));
   col_pn = zeros(num_pn, length(f));
   
   for i=1:length(f)
       temporal=load( [ path '/' f(i).name ] );
       col_an(:,i)=temporal(2:num_an+1, i);
       col_pn(:,i)=temporal(num_an+2:num_pn+num_an+1, i);
   end
     
end